diff --git a/libio/Makefile b/libio/Makefile
index 59f3ee0b7c..57ce64eab2 100644
--- a/libio/Makefile
+++ b/libio/Makefile
@@ -96,6 +96,7 @@ tests = \
   tst-ext \
   tst-ext2 \
   tst-fclose-unopened \
+  tst-fclose-unopened2 \
   tst-fdopen-seek-failure \
   tst-fgetc-after-eof \
   tst-fgetwc \
@@ -251,6 +252,9 @@ LDFLAGS-tst-bz24228 = -Wl,--version-script=tst-bz24228.map
 
 tst_wprintf2-ARGS = "Some Text"
 
+tst-fclose-unopened2-ENV = \
+  MALLOC_TRACE=$(objjpfx)tst-fclose-unopened2.mtrace \
+  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
 test-fmemopen-ENV = MALLOC_TRACE=$(objpfx)test-fmemopen.mtrace \
 		    LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
 tst-fdopen-seek-failure-ENV = \
@@ -275,6 +279,8 @@ generated += \
   tst-bz22415.mtrace \
   tst-bz24228.check \
   tst-bz24228.mtrace \
+  tst-fclose-unopened2.check \
+  tst-fclose-unopened2.mtrace \
   tst-fdopen-seek-failure.check \
   tst-fdopen-seek-failure.mtrace \
   tst-fopenloc.check \
@@ -313,6 +319,7 @@ tests-special += \
   $(objpfx)test-fmemopen-mem.out \
   $(objpfx)tst-bz22415-mem.out \
   $(objpfx)tst-bz24228-mem.out \
+  $(objpfx)tst-fclose-unopened2-mem.out \
   $(objpfx)tst-fdopen-seek-failure-mem.out \
   $(objpfx)tst-fopenloc-mem.out \
   # tests-special
@@ -400,6 +407,11 @@ $(objpfx)test-fmemopen-mem.out: $(objpfx)test-fmemopen.out
 	$(common-objpfx)malloc/mtrace $(objpfx)test-fmemopen.mtrace > $@; \
 	$(evaluate-test)
 
+$(objpfx)tst-fclose-unopened2-mem.out: $(objpfx)tst-fclose-unopened2.out
+	$(common-objpfx)malloc/mtrace \
+	  $(objpfx)tst-fclose-unopened2.mtrace > $@; \
+	$(evaluate-test)
+
 $(objpfx)tst-fdopen-seek-failure-mem.out: $(objpfx)tst-fdopen-seek-failure.out
 	$(common-objpfx)malloc/mtrace \
 	  $(objpfx)tst-fdopen-seek-failure.mtrace > $@; \
diff --git a/libio/tst-fclose-unopened.c b/libio/tst-fclose-unopened.c
index 1f1cad042d..4fed2ffdfe 100644
--- a/libio/tst-fclose-unopened.c
+++ b/libio/tst-fclose-unopened.c
@@ -19,9 +19,11 @@
 #include <stdio.h>
 #include <support/check.h>
 
-/* Verify that fclose on an unopened file returns EOF.  This is not part
-   of the fclose external contract but there are dependancies on this
-   behaviour.  */
+/* Verify that fclose on an unopened file returns EOF.  This test uses
+   a file with an unallocated buffer.
+
+   This is not part of the fclose external contract but there are
+   dependencies on this behaviour.  */
 
 static int
 do_test (void)
diff --git a/libio/tst-fclose-unopened2.c b/libio/tst-fclose-unopened2.c
new file mode 100644
index 0000000000..6b5c811308
--- /dev/null
+++ b/libio/tst-fclose-unopened2.c
@@ -0,0 +1,50 @@
+/* Test using fclose on an unopened file.
+   Copyright (C) 2024 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <mcheck.h>
+#include <stdio.h>
+#include <support/check.h>
+
+/* Verify that fclose on an unopened file returns EOF.  This test uses
+   a file with an allocated buffer.
+
+   This is not part of the fclose external contract but there are
+   dependencies on this behaviour.  */
+
+static int
+do_test (void)
+{
+  mtrace ();
+
+  char buf[6];
+
+  /* Read from the file to ensure its internal buffer is allocated.  */
+  TEST_COMPARE (fread (buf, 1, sizeof (buf), stdin), sizeof (buf));
+
+  TEST_COMPARE (fclose (stdin), 0);
+
+  /* Attempt to close the unopened file and verify that EOF is returned.
+     Calling fclose on a file twice normally causes a use-after-free bug,
+     however the standard streams are an exception since they are not
+     deallocated by fclose.  */
+  TEST_COMPARE (fclose (stdin), EOF);
+
+  return 0;
+}
+
+#include <support/test-driver.c>
diff --git a/libio/tst-fclose-unopened2.input b/libio/tst-fclose-unopened2.input
new file mode 100644
index 0000000000..399f9ba41a
--- /dev/null
+++ b/libio/tst-fclose-unopened2.input
@@ -0,0 +1 @@
+fclose